
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PostgreSQL upsert功能(insert on conflict do)的用法 / iVAN</title>

    <meta name="description" content="PostgreSQL upsert功能(insert on conflict do)的用法 标签 PostgreSQL , upsert , insert on conflict do 背景 PostgreSQL 9.5 引入了一项新功能,UPSERT(insert on conflict do),当插入遇到约束错误时,直接返回,或者改为执行UPDATE. 语法如下 Command: INSERT Description: create new rows in a table Syntax: [ WITH [ RECURSIVE ] with_query [, ...] ] INSER">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PostgreSQL upsert功能(insert on conflict do)的用法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>标签</h3>
<p>PostgreSQL , upsert , insert on conflict do</p>
<hr>
<h2>背景</h2>
<p>PostgreSQL 9.5 引入了一项新功能，UPSERT(insert on conflict do)，当插入遇到约束错误时，直接返回，或者改为执行UPDATE。</p>
<p>语法如下</p>
<pre><code>Command:     INSERT
Description: create new rows in a table
Syntax:
[ WITH [ RECURSIVE ] with_query [, ...] ]
INSERT INTO table_name [ AS alias ] [ ( column_name [, ...] ) ]
    { DEFAULT VALUES | VALUES ( { expression | DEFAULT } [, ...] ) [, ...] | query }
    [ ON CONFLICT [ conflict_target ] conflict_action ]
    [ RETURNING * | output_expression [ [ AS ] output_name ] [, ...] ]  

where conflict_target can be one of:  

    ( { index_column_name | ( index_expression ) } [ COLLATE collation ] [ opclass ] [, ...] ) [ WHERE index_predicate ]
    ON CONSTRAINT constraint_name  

and conflict_action is one of:  

    DO NOTHING
    DO UPDATE SET { column_name = { expression | DEFAULT } |
                    ( column_name [, ...] ) = ( { expression | DEFAULT } [, ...] ) |
                    ( column_name [, ...] ) = ( sub-SELECT )
                  } [, ...]
              [ WHERE condition ]
</code></pre>
<p>PostgreSQL 9.5以前的版本，可以通过函数，或者with语法来实现UPSERT类似的功能。</p>
<h2>9.5+ UPSERT用法举例</h2>
<p>创建一张测试表，其中一个字段为唯一键或者主键。</p>
<pre><code>create table test(id int primary key, info text, crt_time timestamp);
</code></pre>
<p>1. 不存在则插入，存在则更新</p>
<pre><code>test03=# insert into test values (1,'test',now()) on conflict (id) do update set info=excluded.info,crt_time=excluded.crt_time;
INSERT 0 1  

test03=# select * from test;
 id | info |          crt_time
----+------+----------------------------
  1 | test | 2017-04-24 15:27:25.393948
(1 row)  

test03=# insert into test values (1,'hello digoal',now()) on conflict (id) do update set info=excluded.info,crt_time=excluded.crt_time;
INSERT 0 1  

test03=# select * from test;
 id |     info     |          crt_time
----+--------------+----------------------------
  1 | hello digoal | 2017-04-24 15:27:39.140877
(1 row)
</code></pre>
<p>2. 不存在则插入，存在则直接返回(不做任何处理)</p>
<pre><code>test03=# insert into test values (1,'hello digoal',now()) on conflict (id) do nothing;
INSERT 0 0
test03=# insert into test values (1,'pu',now()) on conflict (id) do nothing;
INSERT 0 0
test03=# insert into test values (2,'pu',now()) on conflict (id) do nothing;
INSERT 0 1
test03=# select * from test;
 id |     info     |          crt_time
----+--------------+----------------------------
  1 | hello digoal | 2017-04-24 15:27:39.140877
  2 | pu           | 2017-04-24 15:28:20.37392
(2 rows)
</code></pre>
<h2>9.5- UPSERT用法举例</h2>
<p>用户可以根据实际需求，使用不同的方法</p>
<p>1. 函数</p>
<pre><code>test03=# create or replace function f_upsert(int,text,timestamp) returns void as $$
declare
  res int;
begin
  update test set info=$2,crt_time=$3 where id=$1;
  if not found then
    insert into test (id,info,crt_time) values ($1,$2,$3);
  end if;
  exception when others then
    return;
end;
$$ language plpgsql strict;
CREATE FUNCTION  

test03=# select f_upsert(1,'digoal',now()::timestamp);
 f_upsert
----------  

(1 row)  

test03=# select * from test;
 id |  info  |          crt_time
----+--------+----------------------------
  2 | pu     | 2017-04-24 15:28:20.37392
  1 | digoal | 2017-04-24 15:31:29.254325
(2 rows)  

test03=# select f_upsert(1,'digoal001',now()::timestamp);
 f_upsert
----------  

(1 row)  

test03=# select * from test;
 id |   info    |         crt_time
----+-----------+---------------------------
  2 | pu        | 2017-04-24 15:28:20.37392
  1 | digoal001 | 2017-04-24 15:31:38.0529
(2 rows)  

test03=# select f_upsert(3,'hello',now()::timestamp);
 f_upsert
----------  

(1 row)  

test03=# select * from test;
 id |   info    |         crt_time
----+-----------+---------------------------
  2 | pu        | 2017-04-24 15:28:20.37392
  1 | digoal001 | 2017-04-24 15:31:38.0529
  3 | hello     | 2017-04-24 15:31:49.14291
(3 rows)
</code></pre>
<p>2. WITH语法，用法1</p>
<pre><code>create table test(id int primary key, info text, crt_time timestamp);
</code></pre>
<p>存在则更新，不存在则插入。</p>
<pre><code>with upsert as (update test set info=$info,crt_time=$crt_time where id=$id returning *) insert into test select $id,$info,$crt_time where not exists (select 1 from upsert where id=$id);
</code></pre>
<p>替换变量，进行测试</p>
<pre><code>with upsert as (update test set info='test',crt_time=now() where id=1 returning *) insert into test select 1,'test',now() where not exists (select 1 from upsert where id=1);
</code></pre>
<p>同时插入一条不存在的值，只有一个会话成功，另一个会话会报PK约束错误。</p>
<p>3. WITH语法，用法2</p>
<p>即使表没有PK或者唯一约束，也能保证并发。</p>
<pre><code>create table test(id int, info text, crt_time timestamp);
</code></pre>
<p>3.1 对于记录不存在，可以保证只有一个session插入数据，对于同一条数据更新，先来的session会lock着记录，后来的session会wait。</p>
<pre><code>with
  w1 as(select ('x'||substr(md5('$id'),1,16))::bit(64)::bigint as tra_id),
  upsert as (update test set info=$info,crt_time=$crt_time where id=$id returning *)
  insert into test select $id, $info, $crt_time from w1
    where pg_try_advisory_xact_lock(tra_id) and not exists (select 1 from upsert where id=$id);
</code></pre>
<p>替换变量，进行测试</p>
<pre><code>with
  w1 as(select ('x'||substr(md5('1'),1,16))::bit(64)::bigint as tra_id),
  upsert as (update test set info='digoal0123',crt_time=now() where id=1 returning *)
  insert into test select 1, 'digoal0123', now() from w1
    where pg_try_advisory_xact_lock(tra_id) and not exists (select 1 from upsert where id=1);    

INSERT 0 0  

test03=# select * from test;
 id |    info    |         crt_time
----+------------+---------------------------
  2 | pu         | 2017-04-24 15:28:20.37392
  3 | hello      | 2017-04-24 15:31:49.14291
  1 | digoal0123 | 2017-04-24 15:31:38.0529
(3 rows)  

with
  w1 as(select ('x'||substr(md5('4'),1,16))::bit(64)::bigint as tra_id),
  upsert as (update test set info='digoal0123',crt_time=now() where id=4 returning *)
  insert into test select 4, 'digoal0123', now() from w1
    where pg_try_advisory_xact_lock(tra_id) and not exists (select 1 from upsert where id=4);    

INSERT 0 1  

test03=# select * from test;
 id |    info    |          crt_time
----+------------+----------------------------
  2 | pu         | 2017-04-24 15:28:20.37392
  3 | hello      | 2017-04-24 15:31:49.14291
  1 | digoal0123 | 2017-04-24 15:31:38.0529
  4 | digoal0123 | 2017-04-24 15:38:39.801908
(4 rows)
</code></pre>
<p>3.2 对于记录不存在，可以保证只有一个session插入数据，对于同一条数据更新，先来的session会更新数据，后来的session不等待，直接失败。</p>
<pre><code>with w1 as(select ('x'||substr(md5('$id'),1,16))::bit(64)::bigint as tra_id),
  upsert as (update test set info=$info,crt_time=$crt_time from w1 where pg_try_advisory_xact_lock(tra_id) and id=$id returning *)
  insert into test select $id,$info,$crt_time from w1
    where pg_try_advisory_xact_lock(tra_id) and not exists (select 1 from upsert where id=$id);
</code></pre>
<p>替换变量，进行测试</p>
<pre><code>with w1 as(select ('x'||substr(md5('1'),1,16))::bit(64)::bigint as tra_id),
  upsert as (update test set info='test',crt_time=now() from w1 where pg_try_advisory_xact_lock(tra_id) and id=1 returning *)
  insert into test select 1,'test',now() from w1
    where pg_try_advisory_xact_lock(tra_id) and not exists (select 1 from upsert where id=1);    

INSERT 0 0  

test03=# select * from test;
 id |    info    |          crt_time
----+------------+----------------------------
  2 | pu         | 2017-04-24 15:28:20.37392
  3 | hello      | 2017-04-24 15:31:49.14291
  4 | digoal0123 | 2017-04-24 15:42:50.912887
  1 | test       | 2017-04-24 15:44:44.245167
(4 rows)  </code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 03:02:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ad%98%e5%82%a8%e4%b8%8e%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据存储与数据库">数据存储与数据库</a>, <a href="https://www.iamivan.net/tag/postgresql/" title="PostgreSQL">PostgreSQL</a>, <a href="https://www.iamivan.net/tag/create/" title="Create">Create</a>, <a href="https://www.iamivan.net/tag/session/" title="session">session</a>, <a href="https://www.iamivan.net/tag/update/" title="update">update</a>, <a href="https://www.iamivan.net/tag/test/" title="test">test</a>, <a href="https://www.iamivan.net/tag/timestamp/" title="timestamp">timestamp</a>, <a href="https://www.iamivan.net/tag/digoal/" title="Digoal">Digoal</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PostgreSQL upsert功能(insert on conflict do)的用法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLoZR0M.html" rel="bookmark">Greenplum merge insert 用法与性能 &lpar;insert on conflict&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , Greenplum , merge insert , insert on conflict , 合并插入 , 有则更新 , 无则插入 背景 PostgreSQL insert on conflict语法非常强大,支持合并写入(当违反某唯一约束时,冲突则更新,不冲突则写入),同时支持流式计算. 流计算例子链接: &lt;PostgreSQL 流式统计 - insert on conflict 实现 流式 UV(distinct), min, max, avg, sum,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2P4nb.html" rel="bookmark">HTAP数据库 PostgreSQL 场景与性能测试之 22 - &lpar;OLTP&rpar; merge insert&vert;upsert&vert;insert on conflict&vert;合并写入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , HTAP , OLTP , OLAP , 场景与性能测试 背景 PostgreSQL是一个历史悠久的数据库,历史可以追溯到1973年,最早由2014计算机图灵奖得主,关系数据库的鼻祖Michael_Stonebraker 操刀设计,PostgreSQL具备与Oracle类似的功能.性能.架构以及稳定性. PostgreSQL社区的贡献者众多,来自全球各个行业,历经数年,PostgreSQL 每年发布一个大版本,以持久的生命力和稳定性著称. 2017年10月,Pos			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/4MYKZzy.html" rel="bookmark">PostgreSQL 流式统计 - insert on conflict 实现 流式 UV&lpar;distinct&rpar;&comma; min&comma; max&comma; avg&comma; sum&comma; count &period;&period;&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , 流式统计 , insert on conflict , count , avg , min , max , sum 背景 流式统计count, avg, min, max, sum等是一个比较有意思的场景,可用于实时大屏,实时绘制统计图表. 比如菜鸟.淘宝.阿里游戏.以及其他业务系统的FEED日志,按各个维度实时统计输出结果.(实时FEED统计,实时各维度在线人数等) PostgreSQL insert on conflict语法以及rule, trigger的功			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M941P4b.html" rel="bookmark">postgresql 9&period;5版本之前实现upsert功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近有开发人员问,有没有办法实现在pg9.5版本之前实现upsert功能,现整理如下 --创建测试表,注意此处先不要主键或唯一约束 create table t2 (id int,name varchar(100)); -- pg 在9.5之前实现不存在则插入 -- 现在需要实现,当id字段的值存在时,则更新name字段的值,如果id字段的值不存在,则执行插入 with upsert as (update t2 set name='rudy1' where id=5 returning *) i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5o4kAb.html" rel="bookmark">阿里云AliCloudDB PostgreSQL 分区表功能性能比社区版提升100倍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云PostgreSQL 数据库即将推出的分区表功能. 实际测试case比社区版基于触发器的分区表插入性能提升1184倍,比基于规则的触发器插入性能提升159倍. 测试case: 1000张分区表,按INT8类型范围分区,每个分区2000万记录,测试查询,插入性能. 测试结果 1. 非分区表 查询1条记录耗时 9 毫秒 插入1010001条记录 9 秒 2. 阿里PostgreSQL 分区表 查询1条记录耗时 (第1个分区) 89 毫秒 查询1条记录耗时 (第996个分区) 93 毫秒 插入1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z72P2Rp.html" rel="bookmark">铁庵：NoSQL、RDS和大数据异构融合实战，详解PostgreSQL FDW功能原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				直播视频: (点击图片查看视频) 幻灯片下载地址:https://oss-cn-hangzhou.aliyuncs.com/yqfiles/e95acb3cc257c377ad8df5e944760638.pdf Why PostgreSQL ? 图一  PostgreSQL的发展历程 PostgreSQL的前身为ingres Database,从1973年伯克利分校的Ingres项目至今,PostgreSQL现已经过了几十年的发展.相比较于广泛使用MySQL开源数据库,我们之所以对Postgr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8NDglb.html" rel="bookmark">PostgreSQL jdbc batch insert</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , jdbc , batch , addbatch , executebatch , insert 背景 如何快速的将数据导入数据库? 比如ETL程序,数据还原程序,数据初始化,数据同步等场景都会有这样的诉求. 从几个方面来分析 1. 统计信息 PostgreSQL会自动统计表的统计信息,包括柱状图等.会有一定的开销,所以在做批量导入时,可以先关闭表的autovacuum. 2. 索引 构造索引,会有一定的CPU和IO开销,影响导入速度,所以可以在数据导入后再建索引.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQXKnp.html" rel="bookmark">postgresql 源码 insert 返回字段说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--当我们插入一条数据到数据库时,pg会返回给我们如下信息, postgres=# insert into test_2(id) select n from generate_series(1,10000) n; INSERT 0 10000 --第一列说明是插入动作,第三列表示插入了多少行,那么第二列是什么呐 --查看源码,可知 ProcessQuery(PlannedStmt *plan, const char *sourceText, ParamListInfo params, DestR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zenQQ8b.html" rel="bookmark">postgresql upsert 使用范例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--pg支持 update from 语法  postgres=# create table t1 as select n id,'rudy'||n as name from generate_series(1,3) n; SELECT 10 postgres=# select * from t1;  id |  name   ----+--------   1 | rudy1   2 | rudy2   3 | rudy3 (3 rows) --创建表 postgres=# create ta			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boLmXM.html" rel="bookmark" class="title">016-类与对象-OC笔记</a>
					<div>
						学习目标 1.[理解]对象在内存中的存储 2.[理解]nil和NULL 3.[了解]#pragma mark分组导航标记 4.[理解]方法与函数 5.[掌握]多文件开发 6.[掌握]对象和方法 7.[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEZ0qM.html" rel="bookmark" class="title">HTML语言剖析（十一）排版标记</a>
					<div>
						&lt;FRAMESET&gt; &lt;FRAME&gt; &lt;NOFRAMES&gt; &lt;IFRAME&gt; ■ 框架概念 : 所谓框架便是网页画面分成几个框窗,同时取得多个 URL. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrmQyb.html" rel="bookmark" class="title">互联网葬身的棺材</a>
					<div>
						一轮一轮的烘托,互联网成了一个宗教.打着国际的.创新的.高科技的旗号,多数的教主都在胡说八道!大破大立的影响着人们的思维模式和生活模式,也许是那一点虚幻的自由和那一点自由的虚幻,诱惑着真的假的,正的邪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvOqrp.html" rel="bookmark" class="title">利用JSP直接绘制图片并输出到IE里</a>
					<div>
						js 以下代码经测试成功, 直接复制到JSP中即可以运行 &lt;%@ page import=&quot;java.awt.*&quot; %&gt;&lt;%@ page import=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPrYQz.html" rel="bookmark" class="title">企业守护神 和力记易推&OpenCurlyDoubleQuote;UPM数据库保镖&rdquo;</a>
					<div>
						信息化技术的全面发展使得更多企业和组织的运营越来越依赖于 IT 系统,而基于 IT 系统运营所产生的大量信息就成为了企业最为宝贵的一项资源.在国内,财务软件.进销存软件.ERP.CRM等一系列管理软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj78YZM.html" rel="bookmark" class="title">一步一步SharePoint 2007之四十七</a>
					<div>
						实现Excel Service(2)--配置Excel Service支持 摘要 本篇文章将介绍实现Excel Service的第二部分--配置Excel Service支持. 正文 下面将记录每一步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62aVgM.html" rel="bookmark" class="title">UVa 729 The Hamming Distance Problem：全排列输出及小细节</a>
					<div>
						729 - The Hamming Distance Problem Time limit: 3.000 seconds http://uva.onlinejudge.org/index.php?op ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOw0Xqz.html" rel="bookmark" class="title">FLASH AS鼠标拖拽与旋转MC教程</a>
					<div>
						 在网上看到某个游戏既要拖拽mc又要旋转mc,拖拽用鼠标事件实现,而旋转需要用shift+鼠标click事件.总觉得太麻烦了.故而希望自己能找到一种只用鼠标就能同时实现拖拽与旋转功能的方法. 结果发现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLRV8b.html" rel="bookmark" class="title">Win10如何一步快速重装系统</a>
					<div>
						  如何用一步来快速重装Win10系统. 一.打开Win10小娜,在搜索栏或者&quot;运行&quot;中输入&quot;systemreset&quot;后回车开启,如图: 二.执行后在弹出的页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw7n4b.html" rel="bookmark" class="title">shell&mdash;&mdash;切分文件名</a>
					<div>
						  例子: 1. file_jpg=&quot;sample.jpg&quot; name=${file_jpg%.*} echo File name is $name File name is sa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL3nvb.html" rel="bookmark" class="title">mac地址修改器怎么用？</a>
					<div>
						  首先要找到计算机原来的mac地址: 第一步:右键&quot;我的电脑&quot;,再点一下&quot;属性&quot; 然后你会看到这个熟悉的窗口 点一下&quot;设备管理器&quot; 在&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw578p.html" rel="bookmark" class="title">xp系统声卡不支持混音功能的解决方法</a>
					<div>
						  小编先向大家介绍一下立体混音的概念.简单举个例子:电脑一般有三个声道,左声道(左边喇叭),右声道(右边喇叭),立体声道,左右声道可能声音会因为音频视频格式文件而发出不同的声音,而立体声道就是左右两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7BYEb.html" rel="bookmark" class="title">局域网的限制技术和反限制技巧</a>
					<div>
						  一.单纯的限制某些网站,不能访问,网络游戏(比如联众)不能玩,这类限制一般是限制了欲访问的IP地址. 对于这类限制很容易突破,用普通的HTTP代理就可以了,或者SOCKS代理也是可以的.现在网上找 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Qgmp.html" rel="bookmark" class="title">mysql-win7系统安装 VC&plus;&plus;时候提示无权限操作dll文件？</a>
					<div>
						问题描述 win7系统安装 VC++时候提示无权限操作dll文件? 微软官网下载的,先是普通用户登录的,先安装2012版的提示无权限操作dll文件,启用administrator用户,安装还是提示无权 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAro0ep.html" rel="bookmark" class="title">《Redis官方文档》 Pipelining &ndash; 请求应答模式和往返延时</a>
					<div>
						Redis是一个CS结构的TCP服务器,使用&quot;请求-应答&quot;的模式.,客户端发起一个请求是这样的步骤: 客户端发送一个请求给服务器,然后等待服务器的响应,一般客户端使用阻塞模式来等待 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l9m3b.html" rel="bookmark" class="title">简洁的桌面设计如何做到更好？</a>
					<div>
						使用过苹果的Mac 笔记本之后,如果再使用window系统,用户通常的感受就是window系统桌面太罗嗦了,而且使用非常的麻烦,混乱的桌面图标排版,让用户摸不着头脑的帮助系统,这无疑对于设计师而言提出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6jB7z.html" rel="bookmark" class="title">禁止iframe脚本弹出的窗口覆盖了父窗口的方法&lowbar;javascript技巧</a>
					<div>
						我所希望的iframe功能是不要去控制父页面,如果他想要控制,哪从父页面里面加入什么代码能让他无法控制呢? 假如iframe里面有这样的语句:window.parent.location.href=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NVJyM.html" rel="bookmark" class="title">Excel文件和数据库文件的相互转化</a>
					<div>
						http://www.aliyun.com/zixun/aggregation/16544.html&quot;&gt;Excel在对数据进行简单计算和打印设置方面比较体贴用户,而Foxpro在利用编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPG90p.html" rel="bookmark" class="title">揭秘中国刷量&OpenCurlyDoubleQuote;点击农场&rdquo;：两人操纵上万台手机暴利赚钱</a>
					<div>
						本文讲的是揭秘中国刷量&quot;点击农场&quot;:两人操纵上万台手机暴利赚钱,小伙伴们平时上微信.微博时都会看到很多点赞量特高的帖子,对于这种帖子我们一般都比较关注,但是&quot;点击农场&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXWjxz.html" rel="bookmark" class="title">java&period;net&period;SocketTimeoutException&colon; Read timed out</a>
					<div>
						If you get java.net.SocketTimeoutException: Read timed out exception Try setting own timeout value w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm4N8b.html" rel="bookmark" class="title">eclipse-Eclipse 格式化代码的疑惑</a>
					<div>
						问题描述 Eclipse 格式化代码的疑惑 Eclipse格式化代码是什么意思,为什么要格式化,怎样格式化,举个例子. 解决方案 格式化代码就是为了让代码更整洁,增强可读性,便于阅读和排查错误.格式化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkel3wb.html" rel="bookmark" class="title">计算机英语-求推荐计算机相关的英语  是学雅思的单词 还是学托福的单词好&quest;</a>
					<div>
						问题描述 求推荐计算机相关的英语 是学雅思的单词 还是学托福的单词好? 希望大神能帮忙解答,感觉计算机行业需要经常用到外文文档.不知道什么方面的英语能够很好的切合住. 解决方案 事实上雅思.托福未必管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAwd1b.html" rel="bookmark" class="title">servlet-tomcat的web&period;xml有什么用？</a>
					<div>
						问题描述 tomcat的web.xml有什么用? 首先url-pattern servlet-class这两个标签必须把servlet在classes文件下的相对路径写准确,否则无法访问.然后,浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXgr9b.html" rel="bookmark" class="title">新版360导航首页大幅加强了内容的体现</a>
					<div>
						摘要: 新版360导航首页大幅加强了内容的体现 3月18日下午消息, 奇虎360 对外宣布,将对旗下360导航( hao.360.cn )进行全面改版,新版本大幅加强了新闻.影视等内容体现,弱化网址. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqXyvp.html" rel="bookmark" class="title">记一次区域DB突发变慢的SQL优化博弈</a>
					<div>
						作者介绍 黄浩,现任职于中国惠普,从业十年,始终专注于SQL.十年一剑,十年磨砺.3年通信行业,写就近3万条SQL:5年制造行业,遨游在ETL的浪潮:2年性能优化,厚积薄发自成一家.   谨以该优化方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22EK4b.html" rel="bookmark" class="title">步入实质性启动和建设阶段 智慧城市概念迎机遇</a>
					<div>
						2016年第二届物联网与智慧城市国际研讨会5月29至31日在南京举行.大会主办方为国际学术机构工程信息研究院,据了解,本届大会囊括物联网与智慧城市领域所有相关议题,来自全世界各地的科研人员.工程师.学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQq6mp.html" rel="bookmark" class="title">《魔兽世界》负责人李日强：网易被竞争对手暗算了！</a>
					<div>
						&lt;魔兽世界&gt;至今未开服,这离网易董事长丁磊曾承诺的&lt;魔兽世界&gt;开服最后期限6月30日已过去了将近半月. 而最近让丁磊闹心的不仅仅是不能开服,一种广泛流传的&quot;网易暴雪成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv74xM.html" rel="bookmark" class="title">extjs4 tree 的问题</a>
					<div>
						问题描述 varstore=Ext.create('Ext.data.TreeStore',{id:&quot;treestore&quot;,proxy:{type:'ajax',url:'test ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/zJOPo6b.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vZXNzYXkuYjAudXBhaXl1bi5jb20vMTc0Ny8zNjcyNDMvMC5qcGc=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/zJOPo6b.html" rel="bookmark" class="title">大数据时代的邻里生意</a>
					<div>
						       当人们越来越习惯于网上购物,却被&quot;最后一公里&quot;物流所困扰, 当地产商受制于宏观调控.开发住宅利润渐薄,当各种类型的社交媒体被开发占坑之后,人们开始把目光转向了与消费者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPZlZp.html" rel="bookmark" class="title">软通动力：以创新为钥匙，开启转型之门</a>
					<div>
						大数据.云计算.移动互联等新技术以&quot;迅雷不及掩耳之势&quot;席卷全球,在改变人们固有生活方式.思维模式的同时,也颠覆了传统软件企业的研发模式.应用模式以及商业模式,给各个传统企业带来一个 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
